! Reference:
! Chevalet C, Nikolic N, 2009.
! Distribution of coalescence times and distance between microsatellite
! alleles with changing effective population size.
! Theoretical Population Biology 

! Sept 2009
! remplacement de la fonction qui calcule F(alpha)
! par le produit  B0 ( A1 + B1 (A2 + B2( ... ))))
! + extension a un modele avec migration
!
! April 2009
!
! Novembre 2008
! a partir du prog "distri_T_Td.f de avril 08
! extraire calculs des proba Pr(D=d / theta, N ) seulement
! (suffisant pour estim sur paires d'alleles)
! ajouter le calcul de l'esperance Nu de Somme d P(d)
! qui est la quantite utilisee pour l'estim de theta sous
! hypothese que n est constant, et transformer en un 
! theta1 = Nu ( Nu + sqrt(Nu**2+1) )
!
! avec modele general de mutation microsat a plusieurs pas
!
! avec enchainement de calculs selon un fichier parametre
!
! !!!!
! avril 2008
!
! programme combine: distribution de T conditionne ou non
!
! on considere la transforme de Fourier
!
!  F(t*,alpha) = Sum_d alpha**d Pr( T<t* ET Distance=d) 
! 
! en passant en cox(x)  ( alpha = exp( i x )
!
!  F(t*, x)    = Int_0^t* [ exp(-theta*t(1-cos(x)) dP(t) ]
!
! ce qui donne directement 
!  Pr(Dist = d)  pour t* = infini
!  Pr( t<t* )    en faisant  x=0
!  Pr( t<t* | d ) en integrant   F(t*,x) par cos(dx) 
!
! Moments de la distribution du temsp de coalescence
! ed 2 alleles, conditionnes par leur distances (difference du
! nombre de repetitions dans un modele SMM)
!
! cas avec Ne variable 
! (en fonction en escalier parametrage : voir SimulCoal
!
! on part de la transfo Fourier (sur les distances) 
! et Laplace (sur le temps)
!
! en Ne constant on a 
!
! T(x,u) = 
!
! Int_tau { exp(-u*tau) exp(-theta*tau(1-cos x) ) exp(-tau) d.tau
!
!                    1
!        = ----------------------------
!          (1 + u + theta*( 1 - cos x )
!
! en inversant Fourier ( H_d(u) =  Int_x cos( d x) T(x,u) dx )
! on obtient la distribution de T|d par  sa transformee  
!  L_d(u)= H_d(u) / H_d(0)
!
! les moments sont obtenus ensuite en prenant en 0 les derivees de L_d
!
! on peut aussi obtenir directement les derivees L' et L" 
! (et donc les moments) en derivant T(x,u) en u, puis en appliquant
! l'inversion de Fourier
!
! c'est l'approche qu'on  prend pour le cas a Ne variable, 
! pour lequel il semble complique de faire analytiquement
! l'inversion de Fourier : en utilisant les integrations en u
! on obtient explicitement la fonction T(x,u), on calcule ses derivees
! en u, d'ou les expression analytiques de ces derivees pour u=0,
! en fonction de (cos x). Les inversions de Fourier sont alors faites
! numeriquement pour une valeur donnee de (d).
!
! remarque : on  peut generaliser a un SMM etendu en remplacant
! (cos x) par une fonction symetrique  Som_k  c_k cos(kx)
! avec  c_k>0, Som_k c_k = 1.
!
! La formule generale
!
! tailles : N_0, N_1, ... N_j , N_(j+1)
! instants de changements
!         t_0=0, t_1,     t_j , t_(j+1)
!
! temps reduits par 2 N_0
!
! tau_0 = 0,  tau_j = t_j / (2 N_0)
!
! on note aussi :
!
! TT_j = tau_1 + (N_0/N_1) (tau_2 - tau_1) +
!              + ... + (N_0/N_(j-1) ) (tau_j - tau_(j-1) ).
!
! (cela correspondant au calcul d'une moyenne harmonique de la taille
!  car:
!  TT_j = t_1 /2 N_0 + (t_2-t_1)/2 N_1 + ... + (t_j-t_(j-1))/2 N_(j-1)
!  peut s'ecrire
!  t_j /2 Nh ou Nh est la moyenne harmonique des N_j sur la periode (0-t_j)
!
! 
! Resultats :
!
!  T(x,u)  s'ecrit :
!                             N_0   A_j  -  A_(j+1)
!  T(x,u) = Som_(j=0)^(Jmax)  ---  ----------------
!                             N_j        D_j
! avec :
!
!   A_j = exp[ - TT_j - ( u + theta*(1 - cos x) ) tau_j  ]
!
!   D_j = u + ( N_0 / N_j ) + theta*( 1 - cos x )
!
! avec A_0 = 1, A_(Jmax+1) = 0 
!                         (ainsi que les produits par tau_(Jmax+1) )
!
!
!  La fonction T(x,0) donne les proba  H_d(0)  que la distance 
!                     entre 2 alleles soit = d (en integrant par cos(dx) )
!
! les moments s'obtiennent en derivant T(x,u) en u, puis en integrant
! en x ces fonctions prises en u=0
!
! on a
!
!                             N_0       A_j  -  A_(j+1)
!  T'(x,u) = Som_(j=0)^(Jmax) ---  { - ---------------
!                             N_j          (D_j)^2 
!
!                                        tau_j A_j - tau_(j+1)  A_(j+1)
!                                     -  ------------------------------ }
!                                                 D_j 
!
!  et
!                              N_0        A_j  -  A_(j+1)
!  T"(x,u) = Som_(j=0)^(Jmax)  ---  {  2  ---------------
!                              N_j           (D_j)^3 
!
!                                         tau_j A_j  - tau_(j+1) A_(j+1)
!                                    + 2  ------------------------------
!                                             (D_j)^2 
!
!                                        (tau_j)^2 A_j - (tau_(j+1))^2 A_(j+1)
!                                     +  ------------------------------------- }
!                                                  D_j 
!
! Les integrales par cos(dx) donnent
! pour la derivee:         - H_d(0) * E( T_d )
! pour la derivee seconde: + H_d(0) * E( (t_d)^2 )
!
! Notations
!
! tailles efficaces  Neff(0), Neff(1),...,Neff(Jmax)
! restent constantes dans les intervalles de temps
! Instant(0) - Instant(1),
! Instant(1) - Instant(2),
! Instant(2) - Instant(3),
! ...
! ...
! Instant(Jmax) - Infini
! 
! Le temps est compte en remontant le temps vers le passe
!
! unite de temps = (Nombre de generations)/2 Neff(0) 
!
! note : l'usage de NAG impose un common pour passer 
!        les parametres aux fonctions
!
        implicit none
        real*8 X
        
! parametres
!       integer JmaxSup
!       parameter (JmaxSup=10)  
! donnees
        integer Jmax
        real*8 Instant(0:50),Neff(0:50)
        real*8 theta
!
! theta = 4 N_0 mu
!
        real*8 Te,  TeTe(0:50)
        common/donnees/Jmax,theta,Instant,Neff,Tete     
!
        integer i,j
        common/interval/ j

! les fonctions a calculer
!
        real*8 cosmut


        real*8 PI
! declaration NAG:
        integer LW,LIW, IFAIL
        parameter (LW=800,LIW=LW/4)
        real*8  A,B,EPSABS,EPSREL,RESULT,ABSERR
        real*8  W(LW)
        integer IW(LW)
        
!       real*8 GrandTj, X01AAF
!       real*8 GrandA, GranDen  
!       external GrandTj, X01AAF

        real*8 FTXmig, X01AAF
        external FTXmig, X01AAF

                
!       integer KOUNT
!       common/TELNUM/KOUNT
!
! passer aussi le "d" en common pour calculer les integrands
! cos(d*x) * T(x,0)
! dans la fonction appelee par NAG
!
        integer distance
        common/ dis / distance
        
! distribution cumulee aux points de changement

!       real*8 DeltaF(0:50),Fcum(0:50)
        
        real*8 SOMMENU,SOMMEPROB,THETA1,THETA0,PROBAD(0:100)
        real*8 SOMNU2,theta2
        integer IDIS
! essais resultats
        real*8 Hd0
        
! modele SMM etendu de mutations
        real*8 paramut
        real*8 somut,tauxmut
        real*8 modmut(10)
        integer nbs
        integer nbstep,saut(10)
        common/modelmut/paramut,nbstep,saut,modmut      
        
        character*20 ficres

! migration data
        integer Immig, Nefflarge, optimmig
        real*8 grandtheta, ratimmig
        
        common/migration/ Immig,optimmig, ratimmig, grandtheta
!
! Donnees
!       write(*,*)' calcul des moments de T_d avec N variable'
!       write(*,*) '(essais validation de l''algorithme)'
        write(*,*)' '
        write(*,*)' Microsatellite allelic diversity ',
     &  ' after demographic changes'
        write(*,*)' '
        write(*,*) ' Calculus of Pr( D = d / , N_0, N_1, ...),'
        write(*,*) ' the probability that 2 microsatellite alleles',
     &  ' show a difference of  d  repeat motifs'
        write(*,*)' according to past demographic fluctuations'

        write(*,*)' '
        write(*,*)' Give name of output file (max 20 characters)'
        read(*,20) ficres
 20     format(a20)     
        open(25, file = ficres) 

        write(25,*)' Microsatellite allelic diversity ',
     &  ' after demographic changes'
        write(25,*)' '
        write(25,*) ' Calculus of Pr( D = d / , N_0, N_1, ...),'
        write(25,*) ' the probability that 2 microsatellite alleles',
     &  ' show a difference of  d  repeat motifs'
        write(25,*)' according to past demographic fluctuations'        
        
        
!
! modele de mutations
 1000   write(*,*)' '
        write(*,*) ' Calculating the  Pr( D = d / , N_0, N_1, ...) ...'
        write(*,*)' '
 3001   write(*,*)' Enter mutation model / Stop'
        write(*,*)'                 STOP : answer 0'
        write(*,*)'    Single Step Model : answer 1'
        write(*,*)'    Geometric model   : give the ratio c (0 < c < 1)'
        write(*,*)'    Special Model     : ',
     &          'enter the number K of possible steps (K > 1)'
        write(*,*)'                 HELP : ',
     &          'enter a negative number'


        read(*,*) paramut

!
        if(paramut.lt.0D0) then
        write(*,3000)
 3000   format(' Stepwise Mutation Models'/
     &  ' Single Step (answer= 1), one motif is added or withdrawn'/
     &  ' Geometric model (answer a real number c, 0<c<1 )'/
     &  '       under mutation the number of added or withdrawn motifs'/
     &  '       is k with probability equal to  (1-c)*c^(k-1)'/
     &  ' Special model (answer an integer number K, 1 < K <= 10)'/
     &  '       under mutation the number of added or withdrawn motifs'/
     &  '       is k with probability  m_k. '/
     &  '       K pairs of values (k, m_k) must be given')      
     
        goto 3001
        endif

        if(paramut.eq.0D0) stop

        nbstep = paramut        
!       
        if(nbstep.GT.1) then
        write(*,*)
     &  ' For each case, give the number of steps and the probability'
        somut = 0
        do nbs=1,nbstep
        write(*,*)' case ',nbs,': how many steps, which proba ??'
        read(*,*)saut(nbs),modmut(nbs)
        somut = somut + modmut(nbs)
        enddo
! verif somme = 1
        do nbs=1,nbstep
        modmut(nbs)= modmut(nbs)/somut
        enddo
        endif
        
        if(nbstep.eq.1) then  ! cas par defaut nbstep = 1
        saut(1) = 1
        modmut(1) = 1   
        endif

!
        write(*,*)' '
        write(*,*)' Give the current effective size N_0 of',
     &       ' the population'
        read(*,*) Neff(0)
!
        write(*,*)' '
        write(*,*) 'Give the mutation rate '
!       write(*,*)' Donner la valeur de theta = 4 Neff(0) mu'
        read(*,*) tauxmut
        theta = 4 * tauxmut * Neff(0)
!
        write(*,*)' '   
        write(*,*) ' Modelling past variations of population size'
       write(*,*)' size N'
       write(*,*)' '
       write(*,*)'      !'
       write(*,*)'  N_J !                                ___________'
       write(*,*)'      !                               !'
       write(*,*)'  N_2 !             ____  ....'
       write(*,*)'      !            !'
       write(*,*)'  N_1 !       _____!'
       write(*,*)'      !      !'
       write(*,*)'      !      !'
       write(*,*)'  N_0 !______!'
       write(*,*)'      !'
       write(*,*)'      !'
       write(*,*)'      !                                '
       write(*,*)'      !____________________________________________'
       write(*,*)'     '
       write(*,*)'   t_0=0     t_1   t_2     ....      t_J     '
       write(*,*)' '  
       write(*,*)'                                time in the past'
       write(*,*)' '                    
        write(*,*) 'Give the total number of time events (Jmax)',  
     &          '0 if the effective size has been constant'   
        read(*,*) Jmax
        write(*,*)' '
                
          if(Jmax.gt.0) then
        write(*,*) ' Give the series of N_1, N_2, ... N_Jmax.'
        read(*,*) (Neff(i),i=1,Jmax)
        write(*,*) 'Give the series of times  t_1, t_2,...,t_Jmax.'
        read(*,*) (Instant(i),i=1,Jmax)
          endif
! completer par 0 et par l'infini:
        Instant(0) = 0
        Instant(Jmax+1) = 1000000

!
! consider the case of permanent immigration from a large population
! in equilibrium

        write(25,*)' *************** '
        
        

! ecrire
        write(25,*)' '  
        if(nbstep.eq.1) then
        write(25,2008) tauxmut
 2008   format( ' Single Step Mutation model,  =', f8.5)
        elseif (nbstep.gt.1) then
        write(25,2001)tauxmut,nbstep,(saut(nbs),nbs=1,nbstep)
        write(25,2002) (modmut(nbs),nbs=1,nbstep)
 2001   format(' Extended Stepwise Mutation Model with  =',f8.5/
     &   i8,10i8)
 2002   format(8x,10f8.3)
        else            ! geometric model
        write(25,2300) tauxmut, paramut
 2300   format(' Geometric Stepwise Mutation Model, ',
     &  '= ',f8.5,' ratio =',f8.5)
        endif


 
        write(25,2009)Neff(0)
 2009   format(' Current effective size',f8.0)
        if(Jmax.eq.0) then
        write(25,*)' Constant effective size'
        else    
        write(25,*) 'Number of past demographic events =', Jmax
        write(25,*) 'Series of past effective sizes'
        write(25,25) (Neff(j),j=0,Jmax)
        write(25,*) 'Series of times when size changed'
        write(25,25) (Instant(i),i=0,Jmax)
        endif
 25     format(10f8.0)  
 2003   format(f8.2,i8)
 2004   format(10f10.2) 
        

        write(*,*)' Model with immigration ?'
 1001   write(*,*)'   if immigration: answer 1, otherwise: 0'
        read(*,*) Immig
        if(Immig.eq.1) then
! give the size of the large external pop, and
! the migration rate
        write(*,*)' Give the size of the large external population'
        read(*,*) Nefflarge
        grandtheta = 4*Nefflarge*tauxmut

! ecrire

        write(25,1101)Nefflarge,grandtheta 
        
 1101   format(' Assuming immigration from a large population',
     &  ' in equilibrium, of constant size'/
     &  ' Nefext =',i10,' (theta = ',f8.2,' )')

        write(*,*)' Give the immigration rate.',
     &   ' Two options are proposed:'
        write(*,*)'  First option : constant rate'
        write(*,*)' (the number of immigrants is proportional to', 
     &  ' the current population size)' 
        write(*,*)'  Second option: constant number of immigrants'
 1002   write(*,*)' give the option (1 or 2), and the right number'
        read(*,*) optimmig, ratimmig
        
        if(optimmig.eq.1) then
        ratimmig = 4*ratimmig*Neff(0)
        
        write(25,1102) ratimmig
 1102   format(' Constant immigration rate = ',f8.3/
     &  ' (at each generation, the number of immigrants is ',
     &  ' proportional'/' to the current size of the population')
        
        elseif(optimmig.eq.2) then

        write(25,1103) ratimmig
 1103   format(' Constant number of immigrants per generation =',
     &  f8.3)
     
        ratimmig = 4*ratimmig
                
        else
        goto 1002
        endif
                
        else
        if(Immig.ne.0) goto 1001
        write(25,*)' No migration, the population is isolated'
        endif

        

!
! calculer le tableau TeTe()    
        TeTe(0)=0
        Te = 0
        do j=1,Jmax
        Te = Te + (Instant(j)-Instant(j-1) ) / Neff(j-1)
        TeTe(j) = Te / 2
        enddo
!
!       passer aux valeurs reduites
! les "tau_j" sont mis dans le tableau Instant()
! les "N_0/N_j" sont mis dans le tableau "Neff()

        do j=Jmax,0,-1
        Instant(j) = Instant(j) / Neff(0) / 2
        Neff(j) = Neff(0) / Neff(j) 
        enddo


!


! boucle des distances
        
        
        distance = 0
        sommeNu = 0
        sommeProb = 0
        somNU2 = 0

 100    continue        
        
        A=0
        PI = X01AAF(PI)
        B =2.0D0*PI

        EPSABS = 0
        EPSREL = 1D-03

        IFAIL = 1
        call D01AKF(FTXmig,A,B,EPSABS,EPSREL,RESULT,ABSERR,
     &          W,LW,IW,LIW,IFAIL)
        

        Hd0 = RESULT / B
        
        ProbaD(distance) = Hd0
        if(distance.gt.0) Hd0 = 2*Hd0
        SommeProb=SommeProb + Hd0
        sommeNu = sommeNU + distance * Hd0
        somnu2 = somnu2 + Hd0 * (distance**2)
        
        if((SommeProb.lt.0.9999).and.(distance.lt.100)) then
        distance = distance + 1
        goto 100
        endif
! ajuster pour sommeprob < 1
        sommenu = sommenu / sommeprob
        somnu2  = somnu2  / sommeprob
        theta2 = somnu2

        write(*,2005) distance, 1-sommeprob
        write(*,2010) ProbaD(0)
        write(*,102) (ProbaD(idis),idis=1,distance)
        somnu2 = dsqrt( somnu2- sommenu**2)
        write(*,105) sommenu, somnu2
        theta1 = sommeNu*(sommeNu+sqrt(sommeNu**2+1) )

        theta0 = (1/(ProbaD(0)**2) - 1)/2
        write(*,104) theta0
        write(*,103) theta1
        write(*,114) theta2

 102    format(10f8.5)  
 103    format('       theta from mean |D|     =',f10.5)
 104    format('       theta from Homozygosity =',f10.5)
 114    format('       theta from mean D^2     =',f10.5) 
 105    format(' Mean and standard error of |D|:',2f10.5)
! ecrire

        write(25,2005) distance, 1-sommeprob
 2005   format(' Largest value of D used =',i8 /
     &  ' Total probability of unconsidered events =', f8.5)    
        
        write(25,2010) ProbaD(0)
 2010   format( ' Expected homozygosity Pr(D=0) =',f8.5)
        write(25,2006) distance
 2006   format( ' Probabilities Pr(D=1) to Pr(D=',i2,')')
        write(25,102) (ProbaD(idis),idis=1,distance)
 
                
        write(25,105) sommenu, somnu2

        write(25,*) ' Corresponding values of theta = 4N under', 
     &  ' constant population size and SSM,'

        write(25,2007) theta0, theta1, theta2

 2007   format('   from homozygosity :', f10.5/
     &         '   from mean of |D|  :', f10.5/
     &         '   from mean of D^2  :', f10.5)
        
                
        goto 1000
        
        end

! sept 2009             
        real*8 function FTXmig(X)
        implicit none
        integer Jmax
        integer j
        common/interval/ j
        real*8 cosmut,beta,tauden,thecos
        real*8 Instant(0:50),Neff(0:50)
        real*8 TeTe(0:50)       
        real*8 theta,X

        common/donnees/Jmax,theta,Instant,Neff,Tete
        integer distance
        common/ dis / distance
        
        integer Immig,optimmig
        real*8 ratimmig, grandtheta
        common/migration/ Immig,optimmig, ratimmig, grandtheta
        real*8 HHH,Z
        
!       integer KOUNT   
!       real*8 moyftx,moythc
!       common/TELNUM/KOUNT, moyftx,moythc


! calcule valeur theta0 * cosmut(X) une seule fois

        thecos = 1-cosmut(X)
        
        if(Immig.eq.1) HHH = 1/(1+grandtheta*thecos)

        thecos = theta * thecos

! calculer la derniere valeur F_Jmax(x)
        tauden = 1 + thecos / Neff(Jmax)
        Z = 1
        if(immig.eq.1)then
        if(optimmig.eq.1) then
        tauden = tauden + ratimmig
        Z = Z + ratimmig * HHH
        endif
        if(optimmig.eq.2) then
        tauden = tauden + ratimmig/Neff(Jmax)
        Z = Z + ratimmig * HHH/Neff(Jmax)
        endif
        endif   

        FTXmig = Z / tauden
!test
!       KOUNT=KOUNT+1
!       moythc = moythc + thecos
!test
! suite si Jmax > 0

        j = Jmax
        do while (j.ge.1)
        beta = TeTe(j)-Tete(j-1)
        j = j-1
        tauden = 1 + thecos / Neff(j)
        
        if(immig.eq.1)then
        if(optimmig.eq.1) tauden = tauden + ratimmig
        if(optimmig.eq.2) tauden = tauden + ratimmig/Neff(j)
        endif
        
        beta = dexp( - beta*tauden )
        
        Z= 1
        if(immig.eq.1)then
        if(optimmig.eq.1) Z = Z + ratimmig * HHH
        if(optimmig.eq.2) Z = Z + ratimmig * HHH/Neff(j)
        endif
        
        FTXmig = beta*FTXmig + (1-beta)*Z/tauden
        enddo
!test
!       KOUNT=KOUNT+1
!       moyftx = moyftx + FTX
!test                   
        FTXmig = FTXmig * dcos( distance*X )
        
        return
        end
        
        
        
! avril 2009 / ajouter modele geometrique
!       
        real*8 function cosmut(x)
        implicit none
        real*8 x
        real*8 paramut
        real*8 modmut(10)
        integer nbs
        integer nbsaut,saut(10)
        common/modelmut/paramut,nbsaut,saut,modmut
! modele geometrique
        if(nbsaut.eq.0) then
        cosmut= dcos(X)-paramut
        cosmut= (1-paramut)*cosmut
     &          /(1-paramut*(paramut+2*cosmut))
        endif
! modele SMM simple
        if(nbsaut.eq.1) cosmut = dcos(x)
! modele general "a facon"      
        if(nbsaut.gt.1) then
        cosmut=0
        do nbs=1,nbsaut
        cosmut = cosmut + modmut(nbs)*dcos( x*saut(nbs) )
        enddo
        endif
        
        return
        end

      
